## sc-im 0.8.2+ds

=== src/Makefile ===
# Specify the name of the resulting executable file
name = sc-im

# The base directory where everything should be installed.
prefix  = /usr/local

EXDIR   = $(prefix)/bin
HELPDIR = $(prefix)/share/$(name)
LIBDIR  = $(prefix)/share/doc/$(name)

# This is where the man page goes.
MANDIR  = $(prefix)/share/man/man1

# History directory, relative to $HOME
HISTORY_DIR= .cache
HISTORY_FILE=sc-iminfo
# Configuration directory, relative to $HOME
CONFIG_DIR= .config/sc-im
CONFIG_FILE=scimrc

# Change these to your liking or use `make CC=gcc` etc
#CC   = cc
#YACC = bison -y
#SED  = sed

LDLIBS += -lm

CFLAGS += -Wall -g
CFLAGS += -DNCURSES
CFLAGS += -D_XOPEN_SOURCE_EXTENDED -D_GNU_SOURCE
CFLAGS += -DSNAME=\"$(name)\"
CFLAGS += -DHELP_PATH=\"$(HELPDIR)\"
CFLAGS += -DLIBDIR=\"$(LIBDIR)\"

# Sets default pager, e.g. 'less' or 'more'
CFLAGS += -DDFLT_PAGER=\"less\"
# Sets default editor. Its use in case EDITOR env variable is not set
CFLAGS += -DDFLT_EDITOR=\"vim\"
# Comment out to disable color support
CFLAGS += -DUSECOLORS
# Command history file, relative to HISTORY_DIR directory. Comment out to disable commandline history
CFLAGS += -DHISTORY_FILE=\"$(HISTORY_FILE)\" -DHISTORY_DIR=\"$(HISTORY_DIR)\"
# Configuration file, relative to CONFIG_DIR directory
CFLAGS += -DCONFIG_FILE=\"$(CONFIG_FILE)\" -DCONFIG_DIR=\"$(CONFIG_DIR)\"
# Input mode history. Same as previous, but for insert mode commands
CFLAGS += -DINS_HISTORY_FILE=\"sc-iminfo\"
# Comment out to disable undo/redo support
CFLAGS += -DUNDO
# Maximum number of rows in spreadsheet. Up to 1048576
CFLAGS += -DMAXROWS=65536
# Used for date formatting with C-d shortcut using you local d_fmt
CFLAGS += -DUSELOCALE
# Comment out to enable mouse support on virtual terminal.
CFLAGS += -DMOUSE

# Clipboard support is OS dependent.
#
# Choose one of the following commands for copying to different clipboards:
# You can later change it at runtime.
#to copy to tmux clipboard:
CFLAGS += -DDEFAULT_COPY_TO_CLIPBOARD_CMD=\""tmux load-buffer"\"
#to copy to X clipboard:
#CFLAGS += -DDEFAULT_COPY_TO_CLIPBOARD_CMD=\""xclip -i -selection clipboard <"\"
#to copy to OSX clipboard:
#CFLAGS += -DDEFAULT_COPY_TO_CLIPBOARD_CMD=\""pbcopy <"\"
#
# Choose one of the proposed commands for pasting from different clipboards:
# You can later change it at runtime.
CFLAGS += -DDEFAULT_PASTE_FROM_CLIPBOARD_CMD=\""tmux show-buffer"\"
#CFLAGS += -DDEFAULT_PASTE_FROM_CLIPBOARD_CMD=\""xclip -o -selection clipboard"\"
#CFLAGS += -DDEFAULT_PASTE_FROM_CLIPBOARD_CMD=\""pbpaste"\"

# Command to open file or link under cursor
CFLAGS += -DDEFAULT_OPEN_FILE_UNDER_CURSOR_CMD=\""scopen"\"

# Autobackup. If you unset this, no backup check nor autobackup feature will be available.
CFLAGS += -DAUTOBACKUP
# Have threads? Set these two, if you want the autobackup feature to work with threads.
CFLAGS += -DHAVE_PTHREAD

ifneq ($(shell uname -s),Darwin)
  LDLIBS += -pthread
endif

# Check for gnuplot existance
ifneq (, $(shell which gnuplot))
  CFLAGS += -DGNUPLOT
endif

# OpenBSD does not implement wordexp()
ifeq ($(shell uname -s),OpenBSD)
  CFLAGS += -DNO_WORDEXP
endif

# dynamic linking (not available in BSD)
ifneq ($(shell uname -s | grep -o BSD),BSD)
  LDLIBS += -ldl
endif

ifneq (, $(shell which pkg-config))
  # Any system with pkg-config

  # NOTE: ncursesw (required)
  ifeq ($(shell uname -s),Darwin)
    # macOS' ncurses is built with wide-char support
    LDFLAGS += -lncurses
  else ifneq ($(shell pkg-config --exists ncursesw || echo 'no'),no)
    CFLAGS += $(shell pkg-config --cflags ncursesw)
    LDLIBS += $(shell pkg-config --libs ncursesw)
  else ifneq ($(shell pkg-config --exists ncurses || echo 'no'),no)
    # hopefully this includes wide character support then
    CFLAGS += $(shell pkg-config --cflags ncurses)
    LDLIBS += $(shell pkg-config --libs ncurses)
  else
    LDLIBS += -lncursesw
  endif

  # NOTE: libxlsreader (libxls) is required for xls file reading support
  ifneq ($(shell pkg-config --exists libxls || echo 'no'),no)
    CFLAGS += -DXLS $(shell pkg-config --cflags libxls)
    LDLIBS += $(shell pkg-config --libs libxls)
  endif

  # NOTE: libxml and libzip are required for xlsx file import support
  ifneq ($(shell pkg-config --exists libzip libxml-2.0 || echo 'no'),no)
    CFLAGS += -DODS -DXLSX $(shell pkg-config --cflags libxml-2.0 libzip)
    LDLIBS += $(shell pkg-config --libs libxml-2.0 libzip)
  endif

  # NOTE: libxlsxwriter is required for xlsx file export support
  ifneq ($(shell pkg-config --exists xlsxwriter || echo 'no'),no)
    CFLAGS += -DXLSX_EXPORT $(shell pkg-config --cflags xlsxwriter)
    LDLIBS += $(shell pkg-config --libs xlsxwriter)
  endif

  # NOTE: lua support
  ifneq ($(shell pkg-config --exists lua || echo 'no'),no) # Check for user's default lua
    CFLAGS += -DXLUA $(shell pkg-config --cflags lua)
    ifneq ($(shell uname -s),Darwin)
      LDLIBS += $(shell pkg-config --libs lua) -Wl,--export-dynamic
    else
      LDLIBS += $(shell pkg-config --libs lua) -rdynamic
    endif
  else ifneq ($(shell pkg-config --exists luajit || echo 'no'),no) # If not found, check for luajit
    CFLAGS += -DXLUA $(shell pkg-config --cflags luajit)
    ifneq ($(shell uname -s),Darwin)
      LDLIBS += $(shell pkg-config --libs luajit) -Wl,--export-dynamic
    else
      LDLIBS += $(shell pkg-config --libs luajit) -rdynamic
    endif
  endif
else ifeq ($(shell uname -s),Darwin)
  # macOS without pkg-config

  # macOS' ncurses is built with wide-char support
  LDFLAGS += -lncurses
else ifeq ($(shell uname -s),NetBSD)
  # NetBSD without pkg-config

  CFLAGS  += -I/usr/pkg/include
  CFLAGS  += -I/usr/pkg/include/ncursesw

  LDFLAGS += -L/usr/pkg/lib
  LDFLAGS += -Wl,-R/usr/pkg/lib

  LDLIBS += -lncursesw
else
  LDFLAGS += -lncursesw
endif

OBJS = $(patsubst %.c, %.o, $(wildcard *.c) $(wildcard utils/*.c)) gram.o

.PHONY : all clean install docs man_install man_uninstall

all : $(name)

install :
	install -d $(DESTDIR)$(prefix)/bin
	install $(name) $(DESTDIR)$(prefix)/bin/$(name)
	install scopen $(DESTDIR)$(prefix)/bin/scopen
	install -d $(DESTDIR)$(HELPDIR)
	install -m 644 doc $(DESTDIR)$(HELPDIR)/$(name)_help
	install -m 644 $(wildcard plot_*) $(DESTDIR)$(HELPDIR)/
	install -d $(DESTDIR)$(MANDIR)/
	install -m 644 sc-im.1 $(DESTDIR)$(MANDIR)/$(name).1

uninstall :
	-rm $(DESTDIR)$(prefix)/bin/$(name)
	-rm $(DESTDIR)$(HELPDIR)/$(name)_help
	-rm $(DESTDIR)$(HELPDIR)/plot*
	-rm $(DESTDIR)$(MANDIR)/$(name).1

$(name) : $(OBJS)
	$(CC) $(LDFLAGS) $^ -o $@ $(LDLIBS)

$(name)qref: sc.h
	$(CC) $(CFLAGS) $(LDFLAGS) -DQREF $(QREF_FMT) -DSCNAME=\"$(name)\" -o $(name)qref help.c $(LDLIBS)

$(OBJS) : y.tab.h experres.h statres.h

.INTERMEDIATE: y.tab.c
y.tab.c	: gram.y
	$(YACC) -d $<

gram.c : y.tab.c
	mv $< $@

y.tab.h : gram.y | gram.c

experres.h : gram.y eres.sed
	sed -f eres.sed < $< > $@

statres.h : gram.y sres.sed
	sed -f sres.sed < $< > $@

pvmtbl.o: sc.h pvmtbl.c
	$(CC) ${CFLAGS} -c -DPSC pvmtbl.c

docs:
	doxygen Doxyfile

man_install:
	@cp -r ../docs/man/man3/ /usr/local/share/man/
	mandb

# "sc-im" MUST match what is in Doxyfile `MAN_EXTENSION = .sc-im.3`
man_uninstall:
	@rm -rf /usr/local/share/man/man3/*sc-im.3
	@mandb

clean:
	rm -f $(OBJS)
	rm -f experres.h statres.h y.tab.h
	rm -f core gram.c y.output pxmalloc.c pvmtbl.c tags $(name)qref
	rm -f qhelp.c $(name)
	rm -rf ../docs/

=== debian/changelog ===
sc-im (0.8.2+ds-1) unstable; urgency=medium

  * Initial release (Closes: #1002715)

 -- Joshua Peisach <itzswirlz2020@outlook.com>  Fri, 07 Jan 2022 16:17:02 -0500

=== debian/control ===
Source: sc-im
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders:
 Joshua Peisach <itzswirlz2020@outlook.com>
Build-Depends: debhelper-compat (= 13),
 bison,
 gnuplot,
 liblua5.4-dev,
 libncurses-dev,
 libtinfo-dev,
 libxml2-dev,
 libzip-dev
Standards-Version: 4.6.0
Homepage: https://github.com/andmarti1424/sc-im
Vcs-Browser: https://salsa.debian.org/math-team/sc-im
Vcs-Git: https://salsa.debian.org/math-team/sc-im.git
Rules-Requires-Root: no

Package: sc-im
Architecture: any
Depends: libncurses6 | libncursesw6,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: gnuplot,
 libxml2,
 lua5.4,
 xclip,
 zip
Description: Text-based spreadsheet calculator with VI-like keybindings
 Spreadsheet Calculator Improvised, aka sc-im, is an ncurses based,
 vim-like spreadsheet calculator.
 .
 sc-im is based on sc, whose original authors are James Gosling and
 Mark Weiser, and mods were later added by Chuck Martin.
 .
 Its keybindings are familiar to users of 'vi', and it has most
 features that a pure spreadsheet would, but lacks things like
 graphing and saving in foreign formats.  It's very stable and quite
 easy to use once you've put a little effort into learning it.

=== debian/watch ===
version=4
opts=dversionmangle=s/\+ds$//,repacksuffix=+ds,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/$1\.tar\.gz/ \
 https://github.com/andmarti1424/sc-im/tags .*/v?(\d\S*)\.tar\.gz

## sc-im 0.8.3+ds

=== debian/changelog ===
sc-im (0.8.3+ds-1ubuntu1) lunar; urgency=medium

  * Ensure ncurses is linked
  * Copyright: Fix upstream license, add missing clause
  * Add libncursesw-dev as acceptable build dep

 -- Joshua Peisach <itzswirlz2020@outlook.com>  Tue, 28 Mar 2023 12:35:11 -0400

sc-im (0.8.3+ds-1) unstable; urgency=medium

  * New upstream version 0.8.3+ds

  * Update Makefile patch
  * Bump Standards-Version to 4.6.2 (no changes required)

 -- Joshua Peisach <itzswirlz2020@outlook.com>  Mon, 16 Jan 2023 11:06:57 -0500

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,19 @@
 Source: sc-im
 Section: math
 Priority: optional
-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders:
  Joshua Peisach <itzswirlz2020@outlook.com>
 Build-Depends: debhelper-compat (= 13),
  bison,
  gnuplot,
  liblua5.4-dev,
- libncurses-dev,
+ libncurses-dev | libncursesw-dev,
  libtinfo-dev,
  libxml2-dev,
  libzip-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/andmarti1424/sc-im
 Vcs-Browser: https://salsa.debian.org/math-team/sc-im
 Vcs-Git: https://salsa.debian.org/math-team/sc-im.git

## sc-im 0.8.4+ds

=== src/Makefile ===
--- 
+++ 
@@ -58,16 +58,16 @@
 # Choose one of the following commands for copying to different clipboards:
 # You can later change it at runtime.
 #to copy to tmux clipboard:
-CFLAGS += -DDEFAULT_COPY_TO_CLIPBOARD_CMD=\""tmux load-buffer"\"
+#CFLAGS += -DDEFAULT_COPY_TO_CLIPBOARD_CMD=\""tmux load-buffer"\"
 #to copy to X clipboard:
-#CFLAGS += -DDEFAULT_COPY_TO_CLIPBOARD_CMD=\""xclip -i -selection clipboard <"\"
+CFLAGS += -DDEFAULT_COPY_TO_CLIPBOARD_CMD=\""xclip -i -selection clipboard <"\"
 #to copy to OSX clipboard:
 #CFLAGS += -DDEFAULT_COPY_TO_CLIPBOARD_CMD=\""pbcopy <"\"
 #
 # Choose one of the proposed commands for pasting from different clipboards:
 # You can later change it at runtime.
-CFLAGS += -DDEFAULT_PASTE_FROM_CLIPBOARD_CMD=\""tmux show-buffer"\"
-#CFLAGS += -DDEFAULT_PASTE_FROM_CLIPBOARD_CMD=\""xclip -o -selection clipboard"\"
+#CFLAGS += -DDEFAULT_PASTE_FROM_CLIPBOARD_CMD=\""tmux show-buffer"\"
+CFLAGS += -DDEFAULT_PASTE_FROM_CLIPBOARD_CMD=\""xclip -o -selection clipboard"\"
 #CFLAGS += -DDEFAULT_PASTE_FROM_CLIPBOARD_CMD=\""pbpaste"\"
 
 # Command to open file or link under cursor
@@ -82,7 +82,7 @@
   LDLIBS += -pthread
 endif
 
-# Check for gnuplot existance
+# Check for gnuplot existence
 ifneq (, $(shell which gnuplot))
   CFLAGS += -DGNUPLOT
 endif
@@ -101,10 +101,7 @@
   # Any system with pkg-config
 
   # NOTE: ncursesw (required)
-  ifeq ($(shell uname -s),Darwin)
-    # macOS' ncurses is built with wide-char support
-    LDFLAGS += -lncurses
-  else ifneq ($(shell pkg-config --exists ncursesw || echo 'no'),no)
+  ifneq ($(shell pkg-config --exists ncursesw || echo 'no'),no)
     CFLAGS += $(shell pkg-config --cflags ncursesw)
     LDLIBS += $(shell pkg-config --libs ncursesw)
   else ifneq ($(shell pkg-config --exists ncurses || echo 'no'),no)
@@ -134,12 +131,13 @@
   endif
 
   # NOTE: lua support
-  ifneq ($(shell pkg-config --exists lua || echo 'no'),no) # Check for user's default lua
-    CFLAGS += -DXLUA $(shell pkg-config --cflags lua)
+  LUA_PKGNAME ?= $(shell pkg-config --list-all | awk '/^lua-?[0-9.]+[[:space:]]/ { p=$$1; gsub("[^[0-9]", "", p); print p " " $$1; }' | LC_ALL=C sort -nrk1 | uniq | head -n 1 | awk '{print $$2}')
+  ifneq ($(LUA_PKGNAME),)
+    CFLAGS += -DXLUA $(shell pkg-config --cflags $(LUA_PKGNAME))
     ifneq ($(shell uname -s),Darwin)
-      LDLIBS += $(shell pkg-config --libs lua) -Wl,--export-dynamic
+      LDLIBS += $(shell pkg-config --libs $(LUA_PKGNAME)) -Wl,--export-dynamic
     else
-      LDLIBS += $(shell pkg-config --libs lua) -rdynamic
+      LDLIBS += $(shell pkg-config --libs $(LUA_PKGNAME)) -rdynamic
     endif
   else ifneq ($(shell pkg-config --exists luajit || echo 'no'),no) # If not found, check for luajit
     CFLAGS += -DXLUA $(shell pkg-config --cflags luajit)
@@ -149,11 +147,6 @@
       LDLIBS += $(shell pkg-config --libs luajit) -rdynamic
     endif
   endif
-else ifeq ($(shell uname -s),Darwin)
-  # macOS without pkg-config
-
-  # macOS' ncurses is built with wide-char support
-  LDFLAGS += -lncurses
 else ifeq ($(shell uname -s),NetBSD)
   # NetBSD without pkg-config
 
@@ -168,7 +161,7 @@
   LDFLAGS += -lncursesw
 endif
 
-OBJS = $(patsubst %.c, %.o, $(wildcard *.c) $(wildcard utils/*.c)) gram.o
+OBJS = $(patsubst %.c, %.o, $(wildcard *.c) $(wildcard actions/*.c) $(wildcard formats/*.c) $(wildcard cmds/*.c) $(wildcard utils/*.c)) gram.o
 
 .PHONY : all clean install docs man_install man_uninstall

=== debian/changelog ===
sc-im (0.8.4+ds-1ubuntu1) plucky; urgency=medium

  * Merge from Debian unstable (LP: #2089772). Remaining changes:
    - Add libncursesw-dev as acceptable build dep
    - Ensure ncurses is linked
  * Removed obsolete patches/changes:
    - Copyright: Fix upstream license, add missing clause

 -- Dave Jones <dave.jones@canonical.com>  Wed, 27 Nov 2024 14:27:41 +0000

sc-im (0.8.4+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Mon, 19 Aug 2024 08:09:11 +0000

sc-im (0.8.3+ds-4) unstable; urgency=medium

  * Bump standards version to 4.7.0.
  * Add missing header. (Closes: #1073323)

 -- Alex Myczko <tar@debian.org>  Mon, 15 Jul 2024 06:13:15 +0000

sc-im (0.8.3+ds-3) unstable; urgency=medium

  * Upload to unstable.

 -- Gürkan Myczko <tar@debian.org>  Sun, 11 Jun 2023 12:28:30 +0200

sc-im (0.8.3+ds-2) experimental; urgency=medium

  * d/control:
    - add myself to Uploaders.
    - add pkgconf to Build-Depends. (Closes: #1029559)
    - add gvim, w3m, evince as reported by bug. (Closes: #1023267)
    - adjust virtaul package gnuplot.
    - update libtinfo-dev to libncurses-dev.
  * d/copyright: relicensed d/* to BSD-4-clause. (Closes: #1029570)

 -- Gürkan Myczko <tar@debian.org>  Tue, 09 May 2023 19:02:12 +0200

=== debian/control ===
--- 
+++ 
@@ -4,16 +4,17 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders:
- Joshua Peisach <itzswirlz2020@outlook.com>
+ Joshua Peisach <itzswirlz2020@outlook.com>,
+ Alex Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 13),
  bison,
- gnuplot,
+ gnuplot-nox,
  liblua5.4-dev,
  libncurses-dev | libncursesw-dev,
- libtinfo-dev,
  libxml2-dev,
- libzip-dev
-Standards-Version: 4.6.2
+ libzip-dev,
+ pkgconf,
+Standards-Version: 4.7.0
 Homepage: https://github.com/andmarti1424/sc-im
 Vcs-Browser: https://salsa.debian.org/math-team/sc-im
 Vcs-Git: https://salsa.debian.org/math-team/sc-im.git
@@ -23,12 +24,15 @@
 Architecture: any
 Depends: libncurses6 | libncursesw6,
  ${misc:Depends},
- ${shlibs:Depends}
-Recommends: gnuplot,
+ ${shlibs:Depends},
+ w3m,
+Recommends: gnuplot-nox,
+ evince,
  libxml2,
  lua5.4,
+ gvim,
  xclip,
- zip
+ zip,
 Description: Text-based spreadsheet calculator with VI-like keybindings
  Spreadsheet Calculator Improvised, aka sc-im, is an ncurses based,
  vim-like spreadsheet calculator.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# Our sourcefiles are in the 'src' directory. Only queue the
# build processes in the src folder (instead of everthing)
override_dh_auto_build:
	dh_auto_build --sourcedir=src

override_dh_auto_clean:
	dh_auto_clean --sourcedir=src

override_dh_auto_install:
	dh_auto_install --sourcedir=src

override_dh_auto_installdocs:
	dh_auto_installdocs --sourcedir=src

override_dh_strip_nondeterminism:
	# For some reason, debhelper isn't stripping the binary too
	dh_strip && dh_strip_nondeterminism

## sc-im 0.8.5%2Bds

=== debian/changelog ===
sc-im (0.8.5+ds-1) unstable; urgency=medium

  * New upstream version. (Closes: #1097849)

 -- Alex Myczko <tar@debian.org>  Fri, 05 Sep 2025 13:30:57 -0500

## sc-im 0.8.5+ds

=== src/Makefile ===
--- 
+++ 
@@ -6,6 +6,7 @@
 
 EXDIR   = $(prefix)/bin
 HELPDIR = $(prefix)/share/$(name)
+THEMEDIR = $(prefix)/share/themes
 LIBDIR  = $(prefix)/share/doc/$(name)
 
 # This is where the man page goes.
@@ -176,12 +177,14 @@
 	install -m 644 $(wildcard plot_*) $(DESTDIR)$(HELPDIR)/
 	install -d $(DESTDIR)$(MANDIR)/
 	install -m 644 sc-im.1 $(DESTDIR)$(MANDIR)/$(name).1
+	install -d $(DESTDIR)$(THEMEDIR)
+	install -m 644 ../themes/* $(DESTDIR)$(THEMEDIR)
 
 uninstall :
 	-rm $(DESTDIR)$(prefix)/bin/$(name)
 	-rm $(DESTDIR)$(HELPDIR)/$(name)_help
-	-rm $(DESTDIR)$(HELPDIR)/plot*
 	-rm $(DESTDIR)$(MANDIR)/$(name).1
+	-rm -r $(DESTDIR)$(HELPDIR)
 
 $(name) : $(OBJS)
 	$(CC) $(LDFLAGS) $^ -o $@ $(LDLIBS)

=== examples/gui_example/Makefile ===
# Specify the name of the resulting executable file
name = scim

# The base directory where everything should be installed.
prefix  = /usr/local

EXDIR   = $(prefix)/bin
HELPDIR = $(prefix)/share/$(name)
LIBDIR  = $(prefix)/share/doc/$(name)

# This is where the man page goes.
MANDIR  = $(prefix)/man/man1

# Change these to your liking or use `make CC=gcc` etc
#CC   = cc
#YACC = bison -y
#SED  = sed

#ifeq ($(shell uname -s),Darwin)
#  NCURSES_CFLAGS ?=
#  NCURSES_LIBS   ?= -lncursesw
#else ifeq ($(shell pkg-config --exists ncursesw || echo 'no'),no)
#  NCURSES_CFLAGS ?=
#  NCURSES_LIBS   ?= -lncursesw
#else
#  NCURSES_CFLAGS ?= $(shell pkg-config --cflags ncursesw)
#  NCURSES_LIBS   ?= $(shell pkg-config --libs ncursesw)
#endif

#LDLIBS += -lm $(NCURSES_LIBS)
LDLIBS += -lm $(shell pkg-config --libs gtk+-3.0)

CFLAGS += -Wall -g
CFLAGS += $(NCURSES_CFLAGS)
#CFLAGS += -DNCURSES
CFLAGS += -D_XOPEN_SOURCE_EXTENDED -D_GNU_SOURCE
CFLAGS += -DSNAME=\"$(name)\"
CFLAGS += -DHELP_PATH=\"$(HELPDIR)\"
CFLAGS += -DLIBDIR=\"$(LIBDIR)\"
CFLAGS += $(shell pkg-config --cflags gtk+-3.0)

# Sets default pager, e.g. 'less' or 'more'
CFLAGS += -DDFLT_PAGER=\"less\"
# Comment out to disable color support
CFLAGS += -DUSECOLORS
# Command history file, relative to home directory. Comment out to disable commandline history
CFLAGS += -DHISTORY_FILE=\".$(name)info\"
# Input mode history. Same as previous, but for insert mode commands
CFLAGS += -DINS_HISTORY_FILE=\".$(name)info\"
# Comment out to disable undo/redo support
CFLAGS += -DUNDO
# Maximum number of rows in spreadsheet. Up to 1048576
CFLAGS += -DMAXROWS=65536
# Used for date formatting with C-d shortcut using you local d_fmt
CFLAGS += -DUSELOCALE

# Uncomment for basic XLS import. Requires libxlsreader
#CFLAGS += -DXLS
#LDLIBS += -lxlsreader

# NOTE: libxml and libzip are required for xlsx file import support
ifneq ($(shell pkg-config --exists libzip libxml-2.0 || echo 'no'),no)
CFLAGS += -DXLSX $(shell pkg-config --cflags libxml-2.0 libzip)
LDLIBS += $(shell pkg-config --libs libxml-2.0 libzip)
endif

# NOTE: libxlsxwriter is required for xlsx file export support
ifneq (,$(wildcard /usr/include/xlsxwriter.h))
CFLAGS += -DXLSX_EXPORT
LDLIBS += -lxlsxwriter
endif

# NOTE: lua support
ifneq ($(shell pkg-config --exists lua51 || echo 'no'),no)
CFLAGS += -DXLUA $(shell pkg-config --cflags lua51)
LDLIBS += $(shell pkg-config --libs lua51) -Wl,--export-dynamic
endif
# dynamic linking
LDLIBS += -ldl


OBJS = $(patsubst %.c, %.o, $(wildcard *.c) $(wildcard utils/*.c)) gram.o

.PHONY : all clean install

all : $(name)

install :
	install -d $(DESTDIR)$(prefix)/bin
	install $(name) $(DESTDIR)$(prefix)/bin/$(name)
	install -d $(DESTDIR)$(HELPDIR)
	install doc $(DESTDIR)$(HELPDIR)/$(name)_help
	install -d $(DESTDIR)$(prefix)/share/man/man1
	install -m 644 sc-im.1 $(DESTDIR)$(prefix)/share/man/man1/$(name).1

uninstall :
	-rm $(DESTDIR)$(prefix)/bin/$(name)
	-rm $(DESTDIR)$(HELPDIR)/$(name)_help
	-rm $(DESTDIR)$(prefix)/share/man/man1/$(name).1

$(name) : $(OBJS)
	$(CC) $(LDFLAGS) $^ -o $@ $(LDLIBS)

$(name)qref: sc.h
	$(CC) $(CFLAGS) $(LDFLAGS) -DQREF $(QREF_FMT) -DSCNAME=\"$(name)\" -o $(name)qref help.c $(LDLIBS)

$(OBJS) : y.tab.h experres.h statres.h

y.tab.h : gram.y gram.c
	test -f y.tab.c && mv y.tab.c gram.c

gram.c : gram.y
	$(YACC) -d $<

pvmtbl.o: sc.h pvmtbl.c
	$(CC) ${CFLAGS} -c -DPSC pvmtbl.c

experres.h : gram.y
	sed -f eres.sed < gram.y > experres.h

statres.h : gram.y
	sed -f sres.sed < gram.y > statres.h

clean:
	rm -f $(OBJS)
	rm -f *res.h $(YTAB).h
	rm -f core gram.c y.output pxmalloc.c pvmtbl.c tags $(name)qref
	rm -f qhelp.c $(name)

=== examples/ui_example/Makefile ===
# Specify the name of the resulting executable file
name = scim

# The base directory where everything should be installed.
prefix  = /usr/local

EXDIR   = $(prefix)/bin
HELPDIR = $(prefix)/share/$(name)
LIBDIR  = $(prefix)/share/doc/$(name)

# This is where the man page goes.
MANDIR  = $(prefix)/man/man1

# Change these to your liking or use `make CC=gcc` etc
#CC   = cc
#YACC = bison -y
#SED  = sed

#ifeq ($(shell uname -s),Darwin)
#  NCURSES_CFLAGS ?=
#  NCURSES_LIBS   ?= -lncursesw
#else ifeq ($(shell pkg-config --exists ncursesw || echo 'no'),no)
#  NCURSES_CFLAGS ?=
#  NCURSES_LIBS   ?= -lncursesw
#else
#  NCURSES_CFLAGS ?= $(shell pkg-config --cflags ncursesw)
#  NCURSES_LIBS   ?= $(shell pkg-config --libs ncursesw)
#endif

#LDLIBS += -lm $(NCURSES_LIBS)
LDLIBS += -lm

CFLAGS += -Wall -g
CFLAGS += $(NCURSES_CFLAGS)
#CFLAGS += -DNCURSES
CFLAGS += -D_XOPEN_SOURCE_EXTENDED -D_GNU_SOURCE
CFLAGS += -DSNAME=\"$(name)\"
CFLAGS += -DHELP_PATH=\"$(HELPDIR)\"
CFLAGS += -DLIBDIR=\"$(LIBDIR)\"

# Sets default pager, e.g. 'less' or 'more'
CFLAGS += -DDFLT_PAGER=\"less\"
# Comment out to disable color support
CFLAGS += -DUSECOLORS
# Command history file, relative to home directory. Comment out to disable commandline history
CFLAGS += -DHISTORY_FILE=\".$(name)info\"
# Input mode history. Same as previous, but for insert mode commands
CFLAGS += -DINS_HISTORY_FILE=\".$(name)info\"
# Comment out to disable undo/redo support
CFLAGS += -DUNDO
# Maximum number of rows in spreadsheet. Up to 1048576
CFLAGS += -DMAXROWS=65536
# Used for date formatting with C-d shortcut using you local d_fmt
CFLAGS += -DUSELOCALE

# Uncomment for basic XLS import. Requires libxlsreader
#CFLAGS += -DXLS
#LDLIBS += -lxlsreader

# NOTE: libxml and libzip are required for xlsx file import support
ifneq ($(shell pkg-config --exists libzip libxml-2.0 || echo 'no'),no)
CFLAGS += -DXLSX $(shell pkg-config --cflags libxml-2.0 libzip)
LDLIBS += $(shell pkg-config --libs libxml-2.0 libzip)
endif

# NOTE: libxlsxwriter is required for xlsx file export support
ifneq (,$(wildcard /usr/include/xlsxwriter.h))
CFLAGS += -DXLSX_EXPORT
LDLIBS += -lxlsxwriter
endif

# NOTE: lua support
ifneq ($(shell pkg-config --exists lua51 || echo 'no'),no)
CFLAGS += -DXLUA $(shell pkg-config --cflags lua51)
LDLIBS += $(shell pkg-config --libs lua51) -Wl,--export-dynamic
endif
# dynamic linking
LDLIBS += -ldl


OBJS = $(patsubst %.c, %.o, $(wildcard *.c) $(wildcard utils/*.c)) gram.o

.PHONY : all clean install

all : $(name)

install :
	install -d $(DESTDIR)$(prefix)/bin
	install $(name) $(DESTDIR)$(prefix)/bin/$(name)
	install -d $(DESTDIR)$(HELPDIR)
	install doc $(DESTDIR)$(HELPDIR)/$(name)_help
	install -d $(DESTDIR)$(prefix)/share/man/man1
	install -m 644 sc-im.1 $(DESTDIR)$(prefix)/share/man/man1/$(name).1

uninstall :
	-rm $(DESTDIR)$(prefix)/bin/$(name)
	-rm $(DESTDIR)$(HELPDIR)/$(name)_help
	-rm $(DESTDIR)$(prefix)/share/man/man1/$(name).1

$(name) : $(OBJS)
	$(CC) $(LDFLAGS) $^ -o $@ $(LDLIBS)

$(name)qref: sc.h
	$(CC) $(CFLAGS) $(LDFLAGS) -DQREF $(QREF_FMT) -DSCNAME=\"$(name)\" -o $(name)qref help.c $(LDLIBS)

$(OBJS) : y.tab.h experres.h statres.h

y.tab.h : gram.y gram.c
	test -f y.tab.c && mv y.tab.c gram.c

gram.c : gram.y
	$(YACC) -d $<

pvmtbl.o: sc.h pvmtbl.c
	$(CC) ${CFLAGS} -c -DPSC pvmtbl.c

experres.h : gram.y
	sed -f eres.sed < gram.y > experres.h

statres.h : gram.y
	sed -f sres.sed < gram.y > statres.h

clean:
	rm -f $(OBJS)
	rm -f *res.h $(YTAB).h
	rm -f core gram.c y.output pxmalloc.c pvmtbl.c tags $(name)qref
	rm -f qhelp.c $(name)

=== src/latex/Makefile ===
all: refman.pdf

pdf: refman.pdf

refman.pdf: clean refman.tex
	pdflatex refman
	makeindex refman.idx
	pdflatex refman
	latex_count=8 ; \
	while egrep -s 'Rerun (LaTeX|to get cross-references right)' refman.log && [ $$latex_count -gt 0 ] ;\
	    do \
	      echo "Rerunning latex...." ;\
	      pdflatex refman ;\
	      latex_count=`expr $$latex_count - 1` ;\
	    done
	makeindex refman.idx
	pdflatex refman


clean:
	rm -f *.ps *.dvi *.aux *.toc *.idx *.ind *.ilg *.log *.out *.brf *.blg *.bbl refman.pdf

=== debian/changelog ===
sc-im (0.8.5+ds-2) unstable; urgency=medium

  * d/control:
    - drop libxml2 depends. (Thanks Jeremy Bicha)
    - remove double build-depends.
    - drop Rules-Requires-Root.
  * Bump standards version to 4.7.2.
  * d/copyright: bump year.
  * d/watch: update to version 5.

 -- Alex Myczko <tar@debian.org>  Thu, 11 Dec 2025 12:34:21 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: sc-im
 Section: math
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders:
  Joshua Peisach <itzswirlz2020@outlook.com>,
  Alex Myczko <tar@debian.org>
@@ -10,11 +9,11 @@
  bison,
  gnuplot-nox,
  liblua5.4-dev,
- libncurses-dev | libncursesw-dev,
+ libncurses-dev,
  libxml2-dev,
  libzip-dev,
  pkgconf,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/andmarti1424/sc-im
 Vcs-Browser: https://salsa.debian.org/math-team/sc-im
 Vcs-Git: https://salsa.debian.org/math-team/sc-im.git
@@ -28,7 +27,6 @@
  w3m,
 Recommends: gnuplot-nox,
  evince,
- libxml2,
  lua5.4,
  gvim,
  xclip,

=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: s/\+ds$//
Owner: andmarti1424
Project: sc-im
Repacksuffix: +ds
